﻿/*
Vector class
21 November 2008
*/

#include <windows.h>
#include <math.h>
#pragma hdrstop

#include "tlib.h"

#include "CVector.h"

using namespace tlib;
using namespace LithDX;



CVector::CVector()
{
	Z = 0.0;
}



CVector::CVector(double aX, double aY, double aZ)
{
	X = aX;
	Y = aY;
	Z = aZ;
}



double CVector::GetLength() const
{
	return sqrt(X * X + Y * Y + Z * Z);
}



CVector CVector::Normalise() const
{
	double Length = sqrt(X * X + Y * Y + Z * Z);
	if (Length == 0.0)
		throw TException(L"Can't normalise vector of length 0");
	return CVector(X / Length, Y / Length, Z / Length);
}



CVector CVector::operator +(const CVector& aRHS) const
{
	return CVector(X + aRHS.X, Y + aRHS.Y, Z + aRHS.Z);
}



CVector CVector::operator -(const CVector& aRHS) const
{
	return CVector(X - aRHS.X, Y - aRHS.Y, Z - aRHS.Z);
}



void CVector::operator +=(const CVector& aRHS)
{
	X += aRHS.X;
	Y += aRHS.Y;
	Z += aRHS.Z;
}



CVector CVector::operator -() const
{
	return CVector(-X, -Y, -Z);
}



void CVector::Negate()
{
	X = -X;
	Y = -Y;
	Z = -Z;
}



CVector CVector::CrossProduct(const CVector& aLHS, const CVector& aRHS)
{
	double X = aLHS.Y * aRHS.Z - aLHS.Z * aRHS.Y;
	double Y = -aLHS.X * aRHS.Z + aLHS.Z * aRHS.X;
	double Z = aLHS.X * aRHS.Y - aLHS.Y * aRHS.X;
	return CVector(X, Y, Z);
}



double CVector::DotProduct(const CVector& aLHS, const CVector& aRHS)
{
	return aLHS.X * aRHS.X + aLHS.Y * aRHS.Y + aLHS.Z * aRHS.Z;
}