﻿/*
Form Class
20 July 2008
*/

#include <windows.h>
#pragma hdrstop

#include "tlib.h"

#include "CForm.h"

using namespace tlib;
using namespace LithGUI;



CForm::CForm(CGUI* aOwner, TString aClassName, TString aCaption, int aXSize, int aYSize)
{
	mOwner = aOwner;
	mClassName = aClassName;

	int X = (GetSystemMetrics(SM_CXSCREEN) - aXSize) / 2;
	int Y = (GetSystemMetrics(SM_CYSCREEN) - aYSize) / 2;
	mWindow = CreateWindowEx(WS_EX_APPWINDOW, aClassName.Str, aCaption.Str, WS_MINIMIZEBOX |
			WS_MAXIMIZEBOX | WS_POPUPWINDOW | WS_CAPTION, X, Y, aXSize, aYSize, NULL, NULL,
			NULL, this);
	if (mWindow == NULL)
	{
		DWORD Error = GetLastError();
		TString Message = TString::SPrintF(L"CreateWindowEx() failed: %d (0x%08x)", Error, Error);
		throw TException(Message.Str);
	}
}



CForm::~CForm()
{
}



void CForm::Destroy()
{
	if (DestroyWindow(mWindow) == 0)
		throw TException(L"DestroyWindow() failed");
	mWindow = NULL;
}



void CForm::SetVisible(bool aVisible)
{
	ShowWindow(mWindow, aVisible ? SW_SHOW : SW_HIDE);
}