﻿namespace LithUtil
{

enum EOpenMode { omCreate, omRead, omAppend };
enum ESeekMode { smBegin=FILE_BEGIN, smCurrent=FILE_CURRENT, smEnd=FILE_END };

class CFile
{
public:
	CFile(tlib::TString aFilePath, EOpenMode aOpenMode, bool aReadSharing=true);
	~CFile();

	unsigned int Read(tlib::TByte* aBuffer, unsigned int aSize);
	int ReadInt();
	tlib::TString ReadString();
	bool ReadCharacter(int& aCharacter);
	bool ReadLine(tlib::TString& aLine);

	void Write(const tlib::TByte* aBuffer, unsigned int aSize);
	void WriteInt(int aValue);
	void WriteString(tlib::TString aValue);
	void WriteText(tlib::TString aText);

	void Seek(unsigned int aOffset, ESeekMode aSeekMode=smBegin);
	unsigned int GetCurrentPosition();
	bool IsEOF() { return mEOF; }

	void Flush();
	unsigned int GetSize();

private:
	HANDLE mFile;
	bool mEOF;
};

}