namespace tlib
{

template <typename T> class TSPtr
{
public:
	TSPtr()
	{
		FObject = NULL;
		FReferenceCount = NULL;
	}
	TSPtr(T* object)
	{
		FObject = object;
		if (FObject == NULL)
			FReferenceCount = NULL;
		else
		{
			FReferenceCount = new int;
			*FReferenceCount = 1;
		}
	}
	TSPtr(const TSPtr<T>& ptr)
	{
		FObject = ptr.FObject;
		FReferenceCount = ptr.FReferenceCount;
		if (FReferenceCount)
			++*FReferenceCount;
	}
	~TSPtr()
	{
		Release();
	}

	TSPtr<T>& operator =(const TSPtr<T>& ptr)
	{
		Release();
		FObject = ptr.FObject;
		FReferenceCount = ptr.FReferenceCount;
		if (FReferenceCount)
			++*FReferenceCount;
		return *this;
	}

	T* operator ->()
	{
		if (FObject == NULL)
			throw TException(L"Null pointer dereference");
		return FObject;
	}

	operator T*() const
	{
		return FObject;
	}

private:
	T *FObject;
	int *FReferenceCount;

	void Release()
	{
		if (FReferenceCount)
		{
			if (*FReferenceCount == 1)
			{
				delete FObject;
				delete FReferenceCount;
			}
			else
				--*FReferenceCount;
		}
	}
};

}   // namespace tlib